#! /usr/bin/env python

import argparse, os, sys, subprocess

versions = ['CPU', 
            'CPU_OpenMP', 
            'Cuda', 
            'OpenCL', 
            'Cuda_reduction', 
            'OpenCL_reduction']
            
parser = argparse.ArgumentParser()
parser.add_argument('--n', type=int, default=10000000)
parser.add_argument('--version', 
                    nargs="*", 
                    choices=versions,
                    default=versions)
args = parser.parse_args()

for v in args.version:
    e = os.environ.copy()
    if v == 'CPU_OpenMP':
        e['OMP_NUM_THREADS'] = '8'

    subprocess.call([os.path.join('install', 'addition_' + v), str(args.n)],
                    env=e)
