#define IN_MAIN

#include <cstdlib>
#include <iostream>
#include "calcul.hxx"
#include "timer.hxx"
#include "config.hxx"

#ifdef _OPENMP
#include <omp.h>
#endif

int main(int argc, char **argv)
{  
  std::cerr << "Version : CPU OpenMP (" 
            << omp_get_max_threads() << " thread(s) )" << std::endl;
  
  T_AllocId = AddTimer("alloc");
  T_InitId = AddTimer("init");
  T_AddId = AddTimer("add");
  T_VerifId = AddTimer("verif");
  T_FreeId = AddTimer("free");
  AddTimer("total");

  int n = argc > 1 ? strtol(argv[1], NULL, 10) : N;
  
  Timer & T_total = GetTimer(-1);
  T_total.start();
  
  double v;
  {
    Calcul_CPU C(n);
    C.init();
    C.addition();
    v = C.verification();
  }

  T_total.stop();

  std::cout << "erreur " << v << "\n"
	    << std::endl;
  
  PrintTimers(std::cout);
  SaveTimers("2_CPU_OpenMP");
  return 0;
}
