#! /usr/bin/env python

import os, sys, subprocess, platform, shutil

base = os.getcwd()

srcDir = os.path.join(base, 'src')
buildDir = os.path.join(base, 'build')
installDir = os.path.join(base, 'install')

if not os.path.exists(buildDir):
  os.makedirs(buildDir)

with open(os.path.join(buildDir, "build.sh"), "w") as f:
  f.write("\necho\n")
  f.write("module purge\nmodule load cuda\nmodule load cmake\n")
  f.write("export OCL_ROOT=${CUDA_HOME}\n")
  f.write("cmake -DOpenCL_LIBRARY=${OCL_ROOT}/lib64/libOpenCL.so -DOpenCL_INCLUDE_DIR=${OCL_ROOT}/include -DCMAKE_INSTALL_PREFIX=" + installDir + \
          " " + srcDir + "\n")
  f.write("make --no-print-directory install\n")

err = subprocess.call(['bash', './build.sh'], cwd=buildDir)
if not err == 0:
  sys.exit(-1)


