#! /usr/bin/env python
# -*- coding: utf-8 -*-

try:
    unicode('')
except NameError:
    unicode = str

import os, sys, argparse, time
from subprocess import *

parser = argparse.ArgumentParser()

versions = ['CPU', 'CPU_OpenMP', 'Cuda', 'OpenCL', 'Cuda_reduction', 'OpenCL_reduction']
parser.add_argument('--version', nargs="*", choices=versions, default=versions)
args = parser.parse_args()

baseDir = os.path.dirname(os.path.realpath(__file__))
installDir = os.path.join(baseDir, 'install')

for v in args.version:
  code = os.path.join(installDir, 'addition_' + v)

  job = '''#!/bin/bash

#SBATCH --job-name=@VERSION@
#SBATCH --output=output_@K@_@VERSION@.txt
#SBATCH --error=output_@K@_@VERSION@.txt

#SBATCH --partition=gpu
#SBATCH --gres=gpu:1
#SBATCH --account=ams301

#SBATCH --time=00:05:00
#SBATCH --ntasks=1

@OPENMP@

## load modules
module purge
module load cuda

## execution
@COMMANDE@
'''

  s = job
  for k in range(len(versions)):
     if v == versions[k]:
        s = s.replace("@K@", str(k+1))
  s = s.replace("@VERSION@", v)
  s = s.replace("@COMMANDE@", code)
  if v == "CPU_OpenMP":
     s = s.replace("@OPENMP@", 
        "#SBATCH --cpus-per-task=8\n\nexport OMP_NUM_THREADS=8\n")
  else:
     s = s.replace("@OPENMP@", "")

  jobFile = 'job_' + v + '.sh'
  with open(jobFile, 'w') as f:
     f.write(s)

  call(['sbatch', jobFile])
