#define IN_MAIN

#include "timer.hxx"
#include "io_png.hxx"
#include "operation.h"
#include <stddef.h>
#include <iostream>
#include <string>
#include "os.hxx"
#include "version.hxx"

const char pathSeparator =
#ifdef _WIN32
      '\\';
#else
      '/';
#endif

int main(int argc, char **argv)
{
  Timer T_global;
  T_global.start();
  
  std::string fileIn, fileOut;
  cImage imageIn, imageOut;
 
  std::string defaultIn = "images";
  defaultIn += pathSeparator;
  defaultIn += "ecureuil.png";

  fileIn = argc > 1 ? argv[1] : defaultIn;
  if (argc > 2) {
    fileOut = argv[2];
  }
  else {
    fileOut = "results";
    fileOut += pathSeparator;
    fileOut += version;
    mkdir_p(fileOut.c_str());
    std::size_t found = fileIn.rfind(pathSeparator);
    found = found == std::string::npos ? 0 : found+1;
    fileOut += pathSeparator;
    fileOut += fileIn.substr(found);
  }
  
  Timer T1, T2, T3;
  T1.start();
  
  imageIn.read_png(fileIn.c_str());
  
  T1.stop();
  std::cerr << std::endl;
  T1.print(1, "Time read file", true);
  
  T2.start();
  
  process(imageOut, imageIn);
  
  T2.stop();
  T2.print(1, "Time processing", true);
  
  T3.start();

  imageOut.write_png(fileOut.c_str());
  
  T3.stop();
  T3.print(1, "Time write file ", true);

  T_global.stop();
  T_global.print(0, "Time (total)");
  return 0;
}
