#! /usr/bin/env python

import os, sys, subprocess, platform, shutil

job = '''#!/bin/bash

#SBATCH --job-name=build
#SBATCH --output=build.txt
#SBATCH --error=build.txt

#SBATCH --partition=gpu
#SBATCH --gres=gpu:1
#SBATCH --account=ams301

#SBATCH --time=00:05:00
#SBATCH --ntasks=1

## load modules
module purge
module load gcc
module load cuda
module load cmake

## compilation
export OCL_ROOT=${CUDA_HOME}
python build.py
'''

with open("job_build.sh", "w") as f:
  f.write(job)

err = subprocess.call(['sbatch', './job_build.sh'])
if not err == 0:
  sys.exit(-1)


