#! /usr/bin/env python
# -*- coding: utf-8 -*-

try:
    unicode('')
except NameError:
    unicode = str

import os, sys, argparse, time
from subprocess import *

parser = argparse.ArgumentParser()

versions = ['cuda', 'opencl']
parser.add_argument('--version', nargs="*", choices=versions, default=versions)
args = parser.parse_args()

baseDir = os.path.dirname(os.path.realpath(__file__))
installDir = os.path.join(baseDir, 'install')

for v in args.version:
  code = os.path.join(installDir, 'deviceQuery_' + v)

  job = '''#!/bin/bash

#SBATCH --job-name=@VERSION@
#SBATCH --output=output_@K@_@VERSION@.txt
#SBATCH --error=output_@K@_@VERSION@.txt

#SBATCH --partition=gpu
#SBATCH --gres=gpu:3
#SBATCH --account=ams301

#SBATCH --time=00:05:00
#SBATCH --ntasks=1

## load modules
module purge
module load gcc
module load cuda

## execution
@COMMANDE@
'''

  s = job
  for k in range(len(versions)):
     if v == versions[k]:
        s = s.replace("@K@", str(k+1))
        outputFile = 'output_' + str(k) + '_' + v + '.txt'
        if os.path.exists(outputFile):
           os.unlink(outputFile)
  s = s.replace("@VERSION@", v)
  s = s.replace("@COMMANDE@", code)

  jobFile = 'job_' + v + '.sh'
  with open(jobFile, 'w') as f:
     f.write(s)

  call(['sbatch', jobFile])
